<template>
  <div class=" bg-gray-900 flex flex-col justify-center items-center w-screen h-screen">
    <div class="p-20 bg-gray-800 flex flex-col justify-center items-center min-w-0 min-h-0 rounded">
      <table >
        <tbody class="flex flex-col place-items-center">
          <tr>
            <td class="flex flex-col">
              <label class = "text-gray-200 text-lg text-xs" for="fname">E-mail</label>
              <input id="email" class = "form-input px-4 py-2 my-2 mx-1 hover:outline-none hover:ring
             relative bg-gray-700 rounded text-white text-sm border-0 shadow 
             focus:outline-none focus:ring focus:bg-black ease-linear transition-all duration-150"
             type="text" name="emailField" /></td>
          </tr>
          <tr>
            <td class="flex flex-col">
              <label class = "text-gray-200 text-lg text-xs" for="lname">Password</label>
              <input id="password" class = "form-input px-4 py-2 my-2 mx-1 hover:outline-none hover:ring
             relative bg-gray-700 rounded text-white text-sm border-0 shadow 
             focus:outline-none focus:ring focus:bg-black ease-linear transition-all duration-150"
              type="password" name="passwordField" /></td>
          </tr>
          <tr>
            <td class="flex flex-col">
              <label class = "text-gray-200 text-lg text-xs" for="lname">Username</label>
              <input id="username" class = "form-input px-4 py-2 my-2 mx-1 hover:outline-none hover:ring
             relative bg-gray-700 rounded text-white text-sm border-0 shadow 
             focus:outline-none focus:ring focus:bg-black ease-linear transition-all duration-150"
              type="text" name="usernameField" /></td>
          </tr>
          <tr>
            <td><button class = "my-2 text-white bg-blue-500 hover:border-solid
             hover:border-blue-500 hover:bg-blue-400 hover:text-gray-600
             font-bold uppercase text-xs px-4 py-2 rounded outline-none focus:outline-none
             mr-1 mb-1 ease-linear transition-all duration-150"
             type="button" v-on:click="clear">clear</button></td>
            <td><button class = "mx-1 my-2 text-white bg-blue-500 hover:border-solid
             hover:border-blue-500 hover:bg-blue-400 hover:text-black
             font-bold uppercase text-xs px-16 py-2 rounded outline-none focus:outline-none
             mr-1 mb-1 ease-linear transition-all duration-150" type="button" v-on:click="signup">sign-up</button></td>
          </tr>
        </tbody>
      </table>
      <h1 class="text-gray-200">Already an user? <NuxtLink to="/sign-in"
       class = "text-gray-200 hover:text-blue-800 no-underline hover:underline ease-linear transition-all duration-150">Sign-in</NuxtLink> now! </h1>
      <h1 class = "text-red-500 ease-linear transition-all duration-150">{{message}}</h1>
    </div>
    </div>
</template>



<script>

module.exports = {

    data() {
      return {
        message: " ",
        bordercolor: " "
      }   
    },

    methods : {
      signup(){
          const inputs = document.querySelectorAll(".form-input");
          for(const input of inputs){
            input.classList.remove("ring-2");
            input.classList.remove("ring-red-700");
          }

          const email = document.querySelector("#email").value;
          const password = document.querySelector("#password").value;
          const username = document.querySelector("#username").value;
          
          this.$axios.post('http://localhost:3001/register',{
              email,
              password,
              username
          })
          .then((response) => {
              this.$store.commit("registerToken",response.data.accessToken);
              const id = JSON.parse(atob(response.data.accessToken.split('.')[1])).sub;
              this.$router.push("/users/"+id)
          })
          .catch( (error) => {
            if(error.response){
              this.message=error.response.data;
              if(this.message==='Email and password are required'){
                const input = document.querySelector("#email");
                input.classList.add("ring-2");
                input.classList.add("ring-red-700");
                const input2 = document.querySelector("#password");
                input2.classList.add("ring-2");
                input2.classList.add("ring-red-700");
              }else if(this.message==='Email already exists' || this.message==='Email format is invalid'){
                const input = document.querySelector("#email");
                input.classList.add("ring-2");
                input.classList.add("ring-red-700");
              }else if(this.message==='Password is too short'){
                const input = document.querySelector("#password");
                input.classList.add("ring-2");
                input.classList.add("ring-red-700");
              }
            }
          });
      },
      clear(){
        const inputs = document.querySelectorAll(".form-input");  
        for(const input of inputs){
          input.classList.remove("ring-2");
          input.classList.remove("ring-red-700");
          input.value="";
        }
      }
    }
}
</script>

